// LCD Display for TR 9000 as microwave IF
// Build with CCS PIC C Compiler

#include "rad_lcd.h"
#fuses XT,NOPROTECT,NOWDT
#include <lcd_ra.c>

char d1, d2, d3, d4, d5;
#define INIT_BIT PIN_B2
#define DS1 PIN_A0
#define DS2 PIN_A1
#define DS3 PIN_A2
#define DS4 PIN_A3
#define DS5 PIN_A4

// ** set the conversion value **
// this is the amount to add to low-order MHz
//  to convert to 10368 (4 + 4 = 8)
// -- for 144 = 10368
//#define ADJVAL 4
// -- for 145 = 10368
//#define ADJVAL 3

main() {
   char k;
	int	adjval;

	setup_counters(RTCC_INTERNAL,RTCC_DIV_2);

   lcd_init();
   lcd_init();		// sometimes no disply with
			// just one - ???
   lcd_putc("\f");		// clear display

   lcd_gotoxy(3,1);
   lcd_putc("FREQUENCY:");

   lcd_gotoxy(3,2);
   lcd_putc("10368.100.0");
   d5 = '8';
   d4 = '1';
   d3 = '0';
   d2 = '0';
   d1 = '0';

	delay_us(10);
  	if(input(INIT_BIT)) {
		adjval = 4;
	}else{
		adjval = 3;
	}

	while(1) {
		while(!input(DS1)) ;
		delay_us(2);
		d1 = lcd_read_bus();
		d1 += 0x30;
		if (d1 > '9') d1 = '0';

		while(!input(DS2)) ;
		delay_us(2);
		d2 = lcd_read_bus();
		d2 += 0x30;
		if (d2 > '9') d2 = '0';

		while(!input(DS3)) ;
		delay_us(2);
		d3 = lcd_read_bus();
		d3 += 0x30;
		if (d3 > '9') d3 = '0';

		while(!input(DS4)) ;
		delay_us(2);
		d4 = lcd_read_bus();
		d4 += 0x30;
		if (d4 > '9') d4 = '0';

		while(!input(DS5)) ;
		delay_us(2);
		d5 = lcd_read_bus();
		// make 144 or 145 = 368 (add 4 or 3)
		d5 += adjval;
		if (d5 > 9) d5 -= 0x0a;
		d5 |= 0x30;

		lcd_gotoxy(6,2);  // ouput digits
		// column 6 is positioned at 6 in 10368

		// adjust MHz 10's for overflow
		if (d5 > '5') lcd_putc('6');
		else lcd_putc('7');

		lcd_putc(d5);	 // MHz units
		lcd_putc('.');
		lcd_putc(d4);	 // kilohertz hundreds
		lcd_putc(d3);
		lcd_putc(d2);
		lcd_putc('.');
		lcd_putc(d1);	 // Hz units

		delay_us(10);
	}
}


